<div [ngClass]="{'mat-elevation-z8': showElevation === true}">
  <table mat-table [dataSource]="dataSource" matSort>

  <ng-container matColumnDef="select">
    <th mat-header-cell *matHeaderCellDef>
      <mat-checkbox (change)="$event ? toggleAllRows() : null"
                    [checked]="selection.hasValue() && isAllSelected()"
                    [indeterminate]="selection.hasValue() && !isAllSelected()"
                    >
      </mat-checkbox>
    </th>
    <td mat-cell *matCellDef="let row">
      <mat-checkbox (click)="$event.stopPropagation()"
                    (change)="$event ? selection.toggle(row) : null"
                    [checked]="selection.isSelected(row)"
                   >
      </mat-checkbox>
    </td>
  </ng-container>

    <ng-container *ngFor="let field of tableHeader" >
      <ng-container [matColumnDef]="field.field">
        <th
          mat-header-cell
          *matHeaderCellDef
          [ngStyle]="{
            'text-align': field['position'] ? field['position'] : 'left'
          }"
          mat-sort-header
        >
          {{ field.label }}
        </th>
        <td
          mat-cell
          *matCellDef="let element"
          [ngStyle]="{
            'text-align': field['position'] ? field['position'] : 'left'
          }"
        >
          {{ element[field.field] }}
        </td>
      </ng-container>
    </ng-container>

    <ng-container *ngIf="showOptions" matColumnDef="opciones" >
      <th mat-header-cell *matHeaderCellDef style="text-align: center">
        Opciones
      </th>
      <td mat-cell *matCellDef="let element" style="width: 10%">
        <div fxLayout="row" fxLayoutGap="5px" fxLayoutAlign="center center">
          <button
            mat-icon-button
            *ngIf="!this.showUpOrDown"
          >
            <mat-icon class="tableIcon" (click)="$event.stopPropagation(); this.addToCart(element)">add_shopping_cart</mat-icon>
          </button>

          <ng-container *ngIf="this.showUpOrDown">
            <button
            mat-icon-button
          >
            <mat-icon class="tableIcon" (click)="$event.stopPropagation(); this.add(element.id)">add_circle</mat-icon>
          </button>
          <button
          mat-icon-button
        >
          <mat-icon class="tableIcon" (click)="$event.stopPropagation(); this.remove(element.id)">remove_circle</mat-icon>
        </button>
          </ng-container>
          <ng-container *ngIf="this.showAdminOption">
            <button
            mat-icon-button
          >
            <mat-icon class="tableIcon" (click)="$event.stopPropagation(); this.navigateToEdit(element['id'])">edit</mat-icon>
          </button>
          </ng-container>



        </div>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="this.label"></tr>
    <tr mat-row *matRowDef="let row; columns: this.label" (click)="selection.toggle(row)"></tr>
    <tr class="mat-row" *matNoDataRow>
      <td class="mat-cell" [colSpan]="this.label.length">No existen datos para mostrar</td>
    </tr>
  </table>

  <mat-paginator
    [pageSizeOptions]="[5, 10, 20]"
    showFirstLastButtons
  >
  </mat-paginator>
  
</div>
